#!/bin/bash

# WatchData主目录ROOT
DDIR_ROOT=/opt/apps/com.watchdata.pabank
DDIR_FILES=$DDIR_ROOT/files
# 注册到firefox的P11模块名
P11_MODEL_NAME=WD_PKCS11_pabank
# PKCS11 so库名称
PKCS_LIB_NAME=libwdpkcs_pabank_51.so

function installToPath () {
    install_path=$1/pkcs11.txt
    user=$2
    # echo "install_path=$install_path, user=$user"
    # if [ -f /usr/bin/modutil ]; then
    #     echo "modutil -dbdir sql:${install_path} -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
    #     modutil -dbdir sql:${install_path} -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
    # else
    #     echo "$DDIR_FILES/bin/modutil -dbdir sql:${install_path} -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
    #     $DDIR_FILES/bin/modutil -dbdir sql:${install_path} -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
    # fi
    echo "sudo echo \"library=$DDIR_FILES/lib/$PKCS_LIB_NAME
    name=$P11_MODEL_NAME
    \" >> $install_path"
    
    sudo echo "library=$DDIR_FILES/lib/$PKCS_LIB_NAME" >> $install_path
    sudo echo "name=$P11_MODEL_NAME" >> $install_path

    echo "sudo chown $user:$user $install_path -R"
    sudo chown $user:$user $install_path -R
    echo "sudo chmod 777 $install_path -R"
    sudo chmod 777 $install_path -R
}

function createP11DB(){
    create_path=$1
    user=$2
    echo "create_path=$create_path, user=$user"
    sudo chown $user:$user ${create_path}
    if [ -f /usr/bin/modutil ]; then
        modutil -dbdir sql:${create_path} -create -force
    else
        $DDIR_FILES/bin/modutil -dbdir sql:${create_path} -create -force
    fi
}

#find all users
homelist=`ls -d /home/*`
userlist=`compgen -u`

#for each user
for homepath in $homelist
do
    curhomeuser=`basename ${homepath}`
    for checkuser in $userlist
    do
        if [[ "${curhomeuser}" == "${checkuser}" ]] && [[ "${curhomeuser}" != "auditadm" ]] && [[ "${curhomeuser}" != "secadm" ]]; then

            #check curuser/.pki/nssdb exist or create it
            if [ ! -d /home/${curhomeuser}/.pki/nssdb ]; then
                mkdir /home/${curhomeuser}/.pki
                mkdir /home/${curhomeuser}/.pki/nssdb
                createP11DB /home/${curhomeuser}/.pki/nssdb ${curhomeuser}
                echo "sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.pki -R"
                sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.pki -R
                echo "sudo chmod 777 /home/${curhomeuser}/.pki -R"
                sudo chmod 777 /home/${curhomeuser}/.pki -R
            fi

            #check curuser/.pki/nssdb/.config/qaxbrowser exist or create it
            if [ ! -d /home/${curhomeuser}/.pki/nssdb/.config/qaxbrowser ]; then
                mkdir /home/${curhomeuser}/.pki/nssdb/.config
                mkdir /home/${curhomeuser}/.pki/nssdb/.config/qaxbrowser
                createP11DB /home/${curhomeuser}/.pki/nssdb/.config/qaxbrowser ${curhomeuser}
                echo "sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.pki/nssdb/.config -R"
                sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.pki/nssdb/.config -R
                echo "sudo chmod 777 /home/${curhomeuser}/.pki/nssdb/.config -R"
                sudo chmod 777 /home/${curhomeuser}/.pki/nssdb/.config -R
            fi
            
            #check curuser/.config/qaxbrowser/.pki/nssdb exist or create it
            if [ ! -d /home/${curhomeuser}/.config/qaxbrowser/.pki/nssdb ]; then
                mkdir /home/${curhomeuser}/.config/qaxbrowser
                mkdir /home/${curhomeuser}/.config/qaxbrowser/.pki
                mkdir /home/${curhomeuser}/.config/qaxbrowser/.pki/nssdb
                createP11DB /home/${curhomeuser}/.config/qaxbrowser/.pki/nssdb ${curhomeuser}
                echo "sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.config/qaxbrowser -R"
                sudo chown $curhomeuser:$curhomeuser /home/${curhomeuser}/.config/qaxbrowser -R
                echo "sudo chmod 777 /home/${curhomeuser}/.config/qaxbrowser -R"
                sudo chmod 777 /home/${curhomeuser}/.config/qaxbrowser -R
            fi
        fi
    done
done
    
#find all pkcs11.txt
p11list=`sudo find /home -name pkcs11.txt`
#for each pkcs11.txt
for curp11 in $p11list
do
    echo "curp11=${curp11}"
    tmp1=${curp11#*/home/}
    echo "tmp1=${tmp1}"
    curusr=${tmp1%%/*}
    echo "curusr=${curusr}"
    if [[ "${curusr}" != "auditadm" ]] && [[ "${curusr}" != "secadm" ]]; then
        installToPath ${curp11%/*} $curusr
    fi
done

p11list=`sudo find /root -name pkcs11.txt`
for curp11 in $p11list
do
    echo "curp11=${curp11}"
    path=${curp11%/*}
    echo "path=${path}"
    installToPath $path "root"
done