#!/bin/bash

# pcsc daemon名称
REGIST_SHELL=registsingle.sh

# 文件夹名称
PROJECT_DDIR=/opt/apps/com.watchdata.pabank
FILES_DDIR=/opt/apps/com.watchdata.wdtokenserver/files
PCSC_DDIR=$FILES_DDIR/pcsc

function waitingdpkglockinstall () {
	i=1
	waitingseconds=$1
	while [ $i -le $waitingseconds ]
	do
		result=`lsof /var/lib/dpkg/lock-frontend`
		echo "dpkg lock-frontend"
        echo $result
		if [ "$result" != "" ]; then
			sleep 1
		else
            result=`sudo lsof /var/lib/dpkg/lock`
            echo "dpkg lock"
            echo $result
            if [ "$result" != "" ]; then
                sleep 1
            else
			    sudo dpkg -i $PROJECT_DDIR/depends/*com.watchdata.wdtokenserver_*.deb
			    break
            fi
		fi
	done
}

function getWDTokenVer () {
    filename=$(basename $PROJECT_DDIR/depends/*com.watchdata.wdtokenserver_*.deb)
    substr=${filename#*_}
    substr1=${substr%_*}
    version=${substr1#*_}
    echo $version
}

echo "begin regist wdtokenserver"

#判断版本号并在必要的时候安装WDTokenServer依赖包
packagedver=$(getWDTokenVer)
echo "packagedver=$packagedver"
installedver=`dpkg -l |awk '$2=="com.watchdata.wdtokenserver" { print $3 }'`
echo "installedver=$installedver"
if [ ! $installedver ]; then
	echo "install wdtokenserver pkg"
	waitingdpkglockinstall 30

elif [ x"$installedver" \< x"$packagedver" ]; then
	echo "update wdtokenserver pkg"
	waitingdpkglockinstall 30

else
	#未安装/更新驱动包的情况下，调用WDTokenServer（1.0.7版本往上）的项目单独注册脚本，判断VID/PID是否已经存在，已经注册的话就不重启pcscd
	echo "refresh wdtokenserver regist : registsingle.sh"
	$PCSC_DDIR/$REGIST_SHELL $PROJECT_DDIR/wdtokenserverinfo
fi

echo "end regist wdtokenserver"

echo "begin open tool"

#安装P11
${PROJECT_DDIR}/files/bin/installP11.sh

function getUser {
    user=
    userPath=/run/systemd/users
    userFiles=`ls $userPath`
    for userFile in $userFiles
    do  
        if [ "${userFile}" -ge "500" ];then
            userState=`awk -F= '{ if($1=="STATE") print $2}' ${userPath}/${userFile}`
            if [ ${userState} == "active" ];then
                user=`awk -F= '{ if($1=="NAME") print $2}' ${userPath}/${userFile}`
                break
            fi  
        fi  
    done

    if [ "$user" == "" ];then
        user=root
    fi  
    echo $user
}

showUser=$(getUser)

#打开用户xhost权限
runUser=`whoami`
${PROJECT_DDIR}/files/bin/openxhost.sh $showUser $runUser

#启动用户工具
sudo chmod -R 777 /tmp
cd /tmp
sudo -i -u $showUser -- bash -c "${PROJECT_DDIR}/files/tools/toolminimize.sh"

sudo chmod 777 /tmp
sudo chmod 777 /tmp -R

echo "end open tool"