#! /bin/bash
prog="WDUSBKeytool_pabank"

BIN_PATH=/opt/apps/com.watchdata.pabank/files/tools/
export LD_LIBRARY_PATH=$BIN_PATH:$LD_LIBRARY_PATH

runUser=`whoami`
if [ ! -f "/tmp/toolminimize.txt" ]; then
    echo "created by ${runUser}" >> /tmp/toolminimize.txt
    chmod 777 /tmp/toolminimize.txt
fi
echo "runUser=$runUser" >> /tmp/toolminimize.txt

function getUser {
    user=
    userPath=/run/systemd/users
    userFiles=`ls $userPath`
    for userFile in $userFiles
    do  
        if [ "${userFile}" -ge "500" ];then
            userState=`awk -F= '{ if($1=="STATE") print $2}' ${userPath}/${userFile}`
            if [ ${userState} == "active" ];then
                user=`awk -F= '{ if($1=="NAME") print $2}' ${userPath}/${userFile}`
                
                break
            fi  
        fi  
    done

    if [ "$user" == "" ];then
        user=root
    fi  
    echo $user
}

showUser=$(getUser)
showUID=`id -u $showUser`
xdg_runtime_dir=/run/user/${showUID}
echo "showUser=$showUser, xdg_runtime_dir=$xdg_runtime_dir" >> /tmp/toolminimize.txt

RUNJAR=`ps -o ruser=usernameforlongdispaly -e -o pid,ppid,c,stime,tty,time,cmd| grep ${prog} | grep -v grep | grep ${showUser} | awk '{print $2}'`
if [ "x${RUNJAR}" != "x" ]; then
    echo "Program is already running."
    exit 0
fi

env >> /tmp/toolminimize.txt
cd "${BIN_PATH}"
/opt/apps/com.watchdata.wdtokenserver/files/pcsc/wdtokenserver.sh >> /tmp/toolminimize.txt 2>&1
pwd >> /tmp/toolminimize.txt
locale >> /tmp/toolminimize.txt

if [ ! $XDG_CURRENT_DESKTOP ]; then
    #检查麒麟版本，V10使用MATE样式， SP1使用UKUI
    kylinver=`cat /etc/kylin-build`
    echo $kylinver >> /tmp/toolminimize.txt
    isSP1=`echo $kylinver|grep SP1`
    echo $isSP1 >> /tmp/toolminimize.txt
    if [ ! -n "$isSP1" ]; then
        export XDG_CURRENT_DESKTOP=MATE
    else
        export XDG_CURRENT_DESKTOP=UKUI
    fi
fi
if [ ! $DISPLAY ]; then
    export DISPLAY=:0
fi

if [ ! $XDG_RUNTIME_DIR ]; then
    export XDG_RUNTIME_DIR=$xdg_runtime_dir
fi

echo "---changed---\n" >> /tmp/toolminimize.txt
env >> /tmp/toolminimize.txt

/opt/apps/com.watchdata.wdtokenserver/files/pcsc/wdtokenserver.sh >> /tmp/toolminimize.txt 2>&1

if [ "$runUser" != "$showUser" ]; then
	echo "su $showUser -c ./${prog} --minimize" >> /tmp/toolminimize.txt
    su $showUser -c "./${prog} --minimize >>/tmp/toolminimize.txt 2>&1 &"
else
	echo "./${prog} --minimize" >> /tmp/toolminimize.txt
	./${prog} --minimize >> /tmp/toolminimize.txt 2>&1 &
fi
