#! /bin/bash
prog="WDUIServer_pabank"

BIN_PATH=/opt/apps/com.watchdata.pabank/files/tools
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$BIN_PATH

runUser=`whoami`
if [ ! -f "/tmp/uilog.txt" ]; then
    echo "created by ${runUser}" >> /tmp/uilog.txt
    chmod 777 /tmp/uilog.txt
fi
echo "runUser=$runUser" >> /tmp/uilog.txt

function getUser {
    user=
    userPath=/run/systemd/users
    userFiles=`ls $userPath`
    for userFile in $userFiles
    do  
        if [ "${userFile}" -ge "500" ];then
            userState=`awk -F= '{ if($1=="STATE") print $2}' ${userPath}/${userFile}`
            if [ ${userState} == "active" ];then
                user=`awk -F= '{ if($1=="NAME") print $2}' ${userPath}/${userFile}`
                break
            fi  
        fi  
    done

    if [ "$user" == "" ];then
        user=root
    fi  
    echo $user
}

showUser=$(getUser)
echo "showUser=$showUser" >> /tmp/uilog.txt

RUNJAR=`ps -o ruser=usernameforlongdispaly -e -o pid,ppid,c,stime,tty,time,cmd| grep ${prog} | grep -v grep | grep ${showUser} | awk '{print $2}'`
if [ "x${RUNJAR}" != "x" ]; then
    echo "Program is already running."
    exit 0
fi

env >> /tmp/uilog.txt

cd "${BIN_PATH}"
if [ "$runUser" != "$showUser" -o "$runUser" == "root" ]; then
    echo "call openxhost.sh" >> /tmp/uilog.txt
    ../bin/openxhost.sh $showUser $runUser >> /tmp/uilog.txt
    echo "after openxhost.sh" >> /tmp/uilog.txt
fi

if [ ! $DISPLAY ]; then
    export DISPLAY=`who|grep $showUser|awk -F\( '{print $2}'|awk -F\) '{print $1}'`
fi
if [ ! $LANG ]; then
	export LANG=zh_CN.UTF-8
fi
if [ ! $XAUTHORITY ]; then
	if [ -d "/home/$showUser/.Xauthority/" ]; then
    	export XAUTHORITY=/home/$showUser/.Xauthority
	fi
fi

env >> /tmp/uilog.txt
xhost >> /tmp/uilog.txt
if [ "$runUser" != "$showUser" ]; then
    su $showUser -c "./${prog} >>/tmp/uilog.txt 2>&1 &"
else
    ./${prog} >>/tmp/uilog.txt 2>&1 &
fi