#!/bin/bash

# pcsc 文件夹名称
FILES_DDIR=/opt/apps/com.watchdata.wdtokenserver/files
PCSC_DDIR=$FILES_DDIR/pcsc

#枚举应用目录的根路径。在国产系统上握奇UKey应用都装在/opt/apps下
APP_ROOT=/opt/apps
#枚举深度。为处理握奇UKey应用装在app的子路径下的情况
APP_DEPTH=1
#握奇UKey应用info文件名
APP_INFO_FILENAME=wdtokenserverinfo

APP_INSTALLED_COUNT=0


function waitingdpkglock () {
	#保证此时应用dpkg已经开始执行卸载操作
	sleep 3
	i=1
	waitingseconds=$1
	while [ $i -le $waitingseconds ]
	do
		result=`lsof /var/lib/dpkg/lock-frontend`
		echo "dpkg lock-frontend"
        echo $result
		if [ "$result" != "" ]; then
			sleep 1
		else
            result=`sudo lsof /var/lib/dpkg/lock`
            echo "dpkg lock"
            echo $result
            if [ "$result" != "" ]; then
                sleep 1
            else
			    break
            fi
		fi
	done
}

#根据递归深度枚举子目录并计数已安装的握奇UKey应用
function loop_enum_wdapp () {
    current_folder=$1
    input_depth=$2
    current_depth=$((input_depth+1))
    echo "current_folder=$current_folder, input_depth=$input_depth, current_depth=$current_depth"
    #循环查找当前路径下子目录
    for file in `ls $current_folder`
    do
    echo "parse $current_folder/$file"
    if [ -d "$current_folder/$file" ]; then
        if [ $current_depth -le $APP_DEPTH ]; then
            record_folder=$current_folder
			record_depth=$current_depth
            loop_enum_wdapp "$current_folder/$file" $current_depth
            current_folder=$record_folder
            current_depth=$record_depth
        fi
    elif [ -f "$current_folder/$file" ]; then
        if [ $file == $APP_INFO_FILENAME ]; then
            APP_INSTALLED_COUNT=$((APP_INSTALLED_COUNT+1))
        fi
    fi
    done
}

echo "begin uninstall wdtokenserver"

installedver=`dpkg -l |awk '$2=="com.watchdata.wdtokenserver" { print $3 }'`
if [ $installedver ]; then
	waitingdpkglock 30
	loop_enum_wdapp $APP_ROOT 0
	echo "APP_INSTALLED_COUNT=$APP_INSTALLED_COUNT"

	if [ x"$APP_INSTALLED_COUNT" \< x"1" ]; then
		echo "remove wdtokenserver pkg"
		sudo dpkg -r com.watchdata.wdtokenserver
	fi
fi

sudo chmod 777 /tmp
sudo chmod 777 /tmp -R

echo "end uninstall wdtokenserver"