#! /bin/bash

# pcsc daemon名称
DAEMON_NAME=wdpcscd_v6
# 通讯服务名称
WDSERVER_NAME=WDTokenServer_v6
BIN_PATH=/opt/apps/com.watchdata.wdtokenserver/files/pcsc

lock_file=/tmp/wdtokenserver.lock

#查询文件锁
while [ -f $lock_file ]
do
    pid=`cat $lock_file`
    echo "$lock_file exist, readed pid=$pid"
    ps $pid &>/dev/null
    if [ $? -eq 0 ]; then
        echo "waiting $lock_file"
        sleep 1s
        continue;
    else
        break;
    fi
done

echo "$lock_file in"

#加锁
echo "add $lock_file"
echo $$ > $lock_file

#查询pcscd服务进程存活状态
pidlist=$(ps -ef | grep "$DAEMON_NAME" | grep -v grep | awk '{print $2}')
if [ -n "$pidlist" ];then
    echo "	$DAEMON_NAME is already running"

else
    echo "start $DAEMON_NAME"
    rm /tmp/wdpcscd_v6.*
    $BIN_PATH/$DAEMON_NAME &
fi

#查询通讯服务服务进程存活状态
pidlist=$(ps -ef | grep "$WDSERVER_NAME" | grep -v grep | awk '{print $2}')
if [ -n "$pidlist" ];then
    echo "	$WDSERVER_NAME is already running"

else
    echo "start $WDSERVER_NAME"
    $BIN_PATH/$WDSERVER_NAME &
fi

#释放锁
rm -rf $lock_file
echo "$lock_file free"